"use strict";
import { util } from '../../../util/util.js'
import { fullMap } from '../../../fullMap.js';
import { khcAlert } from '../../../component/alert/khcAlert.js'
let formComponent=null;
let functionMap=new Map();// 使用 Map 来存储多个函数。每个函数都通过 set 方法添加到 Map 中，键是函数名，值是对应的函数。
export function main(jsonConfig) {
    try {
        functionMap.get(jsonConfig.button_method).apply(jsonConfig);
    } catch (error) {
        khcAlert.showSystemError(error.message);
        console.log(error);
    }
}

function fCreate() {
    let jsonConfig=this;
    jsonConfig.formType='create'
    init.call(jsonConfig)
}
functionMap.set('fCreate', fCreate);// 将函数添加到 Map 中

function fEdit() {
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fEdit', fEdit);// 将函数添加到 Map 中

function fButtonCreate(){
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fButtonCreate', fButtonCreate);// 将函数添加到 Map 中

function fButtonEdit(){
    let jsonConfig=this;
    jsonConfig.formType='edit'
    init.call(jsonConfig)
}
functionMap.set('fButtonEdit', fButtonEdit);// 将函数添加到 Map 中

function fDetail() {
    let jsonConfig=this;
    jsonConfig.formType='detail'
    init.call(jsonConfig)
}
functionMap.set('fDetail', fDetail);// 将函数添加到 Map 中

let initButtonTypeFunc=null;//验证代码函数
function init(){
    let jsonConfig=this;
    let objID = jsonConfig.objID;
    let formType = jsonConfig.formType
    if(formType==undefined||formType=='undefined'){//不是新增和编辑表单则退出
        return ;
    }
    formComponent = fullMap.getObj(objID);
    let eleMap=formComponent.getFormMap();
    if(formType=='create'){
        formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
    }else if(formType=='edit'){
        initForm(eleMap)//初始化表单的一些限制,或对更改内容添加标注（添加背景颜色代表该字段被更改过）
        if(eleMap.get('button_type').getValue()=='formButton'){
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        }
    }
    if(initButtonTypeFunc!=null){
        document.getElementById(eleMap.get('button_type').getEleID()).removeEventListener('change', initButtonTypeFunc);
    }
    initButtonTypeFunc= ()=> {
        if(eleMap.get('button_type').getValue()=='formButton'){
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:false,isClearValue:false,isShowDiv:true,isCanNull:true})
        }else{
            formComponent.initEleConfig({fieldArray:fieldArray,isDisabled:true,isClearValue:false,isShowDiv:false,isCanNull:false})
        }
    }


    //验证代码函数
    document.getElementById(eleMap.get('button_type').getEleID()).addEventListener('change', initButtonTypeFunc);
}
functionMap.set('init', init);// 将函数添加到 Map 中

function initForm(eleMap){
}
let fieldArray=[
    'button_show_type'
];



